program DownConn ;
uses dos;
(**********************************************************************
   This program clears a connection to a Novell network.  The user
   MUST have security equivalence to the SUPERVISOR.  Any number of
   connection numbers may be entered on the command line, each
   seperated by a space character.  If nothing is found on the command
   line the user is repeatedly asked for a connection number until a
   value of 0 is entered.  Although many errors are possible the most
   likely ones to be encountered are:

   198 - No Console Operator
   253 - Bad Station Number

*********************************************************************)

var regs : registers ;
 ErrorCode,
 ec : word ;
 x,
 Conn : byte ;

function KillIt(ConnNumber : byte) : word ;

(*********************************************************************
   This is the function that does all the work.  The errorcode is
   returned in AL.  A value of 0 means SUCCESS.  This function closes
   the connection's open files, releases its file locks and on TTS
   servers  it causes the connection's transactions to be aborted.
   If the requesting station clears its own connection, it can no
   longer communicate with the file server.
*********************************************************************)

type RequestBuffer = record
  RequestLength : word ;
  RequestCode,
  ConnNum  : byte
 end ; (* RequestBuffer *)

var InBuf : RequestBuffer ;
 OutBuf : word ;

begin
 with regs do begin
  ah := $E3 ;
  ds := seg(InBuf) ;
  si := ofs(InBuf) ;
  es := seg(OutBuf) ;
  di := ofs(OutBuf)
 end ; (* with do begin *)
 InBuf.RequestLength := 2 ;
 InBuf.RequestCode := $D2 ;
 InBuf.ConnNum := ConnNumber ;
 OutBuf := 0 ;
 msdos(regs) ;
 KillIt := regs.al
end ; (* KillIt *)

procedure DownIt(Number : byte) ;
begin
 write('   Downing connection ',Number) ;
 ErrorCode := KillIt(Number) ;
 if (ErrorCode = 0) then writeln(' ... Downed!')
 else writeln(' ... Error ',Errorcode,
  ' occurred while trying to down connection ',Number)
end ; (* DownIt *)

begin
 writeln('DownConn - V1.0') ;
 writeln ;
 x := 1 ;
 if (paramcount > 0) then repeat
  val(paramstr(x), Conn, ec) ;
  if ((ec = 0) and (Conn <> 0)) then DownIt(Conn) ;
  inc(x)
 until ((ec <> 0) and (Conn = 0))
 else repeat
  Conn := 0 ;
  write('Enter Connection Number: ') ;
  readln(Conn) ;
  if (Conn <> 0) then DownIt(Conn)
 until (Conn = 0)
end. (* DownConn *)

